VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "www.ActiveVB.de"
   ClientHeight    =   2280
   ClientLeft      =   1155
   ClientTop       =   1545
   ClientWidth     =   4545
   LinkTopic       =   "Form1"
   ScaleHeight     =   2280
   ScaleWidth      =   4545
   Begin VB.CommandButton Command1 
      Caption         =   "Beenden"
      Height          =   495
      Left            =   1560
      TabIndex        =   0
      Top             =   1320
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   735
      Left            =   120
      TabIndex        =   1
      Top             =   120
      Width           =   4095
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False

'Dieser Source stammt von http://www.activevb.de
'und kann frei verwendet werden. Fr eventuelle Schden
'wird nicht gehaftet.
'
'Um Fehler oder Fragen zu klren, nutzen Sie bitte unser Forum.
'Ansonsten viel Spa und Erfolg mit diesem Source !
'
'Autor:   Helge Rex   helge@activevb.de
'
'Prft, ob das System kleine oder groe Schriftarten verwendet

Option Explicit

'   Datentyp fr die Funktion
Private Type TEXTMETRIC
    tmHeight As Integer
    tmAscent As Integer
    tmDescent As Integer
    tmInternalLeading As Integer
    tmExternalLeading As Integer
    tmAveCharWidth As Integer
    tmMaxCharWidth As Integer
    tmWeight As Integer
    tmItalic As String * 1
    tmUnderlined As String * 1
    tmStruckOut As String * 1
    tmFirstChar As String * 1
    tmLastChar As String * 1
    tmDefaultChar As String * 1
    tmBreakChar As String * 1
    tmPitchAndFamily As String * 1
    tmCharSet As String * 1
    tmOverhang As Integer
    tmDigitizedAspectX As Integer
    tmDigitizedAspectY As Integer
End Type

'   ... Diverse APIs ...
Private Declare Function GetTextMetrics Lib "gdi32" Alias "GetTextMetricsA" ( _
    ByVal hdc As Long, _
    lpMetrics As TEXTMETRIC _
) As Long
   
Private Declare Function GetDesktopWindow Lib "user32" ( _
) As Long
   
Private Declare Function GetWindowDC Lib "user32" ( _
    ByVal hwnd As Long _
) As Long
   
Private Declare Function ReleaseDC Lib "user32" ( _
    ByVal hwnd As Long, _
    ByVal hdc As Long _
) As Long
   
Private Declare Function SetMapMode Lib "gdi32" ( _
    ByVal hdc As Long, _
    ByVal nMapMode As Long _
) As Long

'   ... Und eine Konstante
Private Const MM_TEXT = 1

Public Function boolUseSmallFonts() As Boolean
    '   Funktion liefert TRUE, wenn das System kleine Schriftarten verwendet,
    '   sonst wird FALSE zurckgegeben
    
    '   Speicher reservieren
    Dim hdc As Long
    Dim hwnd As Long
    Dim PrevMapMode As Long
    Dim tm As TEXTMETRIC

    '   Standard-Rckgabe setzen
    boolUseSmallFonts = True
    
    '   Handle zum desktop ermitteln
    hwnd = GetDesktopWindow()
    
    '   DC vom Desktop auslesen
    hdc = GetWindowDC(hwnd)
    
    '   Konnte DC ermittelt werden?
    If hdc Then
        '   Ja, ScaleMode auf Pixel setzen
        PrevMapMode = SetMapMode(hdc, MM_TEXT)
        
        '   Gre des Systemfonts auslesen
        GetTextMetrics hdc, tm
        
        '   Scalemode zurcksetzen
        PrevMapMode = SetMapMode(hdc, PrevMapMode)
        
        '   DC freigeben
        ReleaseDC hwnd, hdc
        
        '   Ist die Schriftgre grer als 16 Pixel?
        If (tm.tmHeight > 16) Then
            '   Ja, also werden groe Schriftarten verwendet
            boolUseSmallFonts = False
        End If
    End If
End Function

Public Function strGetFontRes() As String
    '   Funktion gibt aus, welche Schriftgre verwendet wird

    '   Werden kleine Schriftarten verwendet?
    If boolUseSmallFonts Then
        '   Ja, Rckgabe entsprechend setzen
        strGetFontRes = "kleine Schriftarten"
    Else
        '   Ja, Rckgabe entsprechend setzen
        strGetFontRes = "groe Schriftarten"
    End If
End Function

Private Sub Command1_Click()
    Unload Me
End Sub

Private Sub Form_Load()
    Me.Label1.Caption = "Das System verwendet " & strGetFontRes
End Sub
